/*
 * naglog.c
 *
 * This program was written to display Nagios logs with the timestamp
 * translated to human-readable (European, Americans are only barely human)
 * format. Don't whine if it doesn't work for you, and don't ask me to add
 * support for other date-formats.
 *
 * Author: Andreas Ericsson
 *
 * Copyright: None. This program is in the public domain.
 *
 * Compile as such:
 *    gcc -O2 -pipe -Wall naglog.c -o naglog
 *
 */

#define _XOPEN_SOURCE

#include <stdio.h>
#include <time.h>
#include <string.h>

int main(int argc, char **argv)
{
	struct tm tm;
	FILE *fp;
	char buf[8192], *str, date[20];
	int i = 1;

	if(argc < 2) fp = stdin;
	else {
		parse_next:
		printf("opening %s\n", argv[i]);
		fp = fopen(argv[i++], "r");
	}

	if(!fp) {
		perror("fopen():");
		return -1;
	}

	while((fgets(buf, sizeof(buf), fp))) {
		memset(&tm, 0, sizeof(struct tm));
		str = strptime(buf, "[%s] ", &tm);
		strftime(date, sizeof(date), "%Y-%m-%d %T", &tm);
		printf("%s: %s", date, str);
	}

	fclose(fp);

	if(i < argc)
		goto parse_next;

	return 0;
}
